/*global fetch*/
"use strict";
(function(){
    
    function $(id){ return document.getElementById(id) }
    function qs(selector){ return document.querySelector(selector) }
    function qsa(selector){ return document.querySelectorAll(selector) }
    
    //put a function in the "testButtonHandler" variable
    let testButtonHandler = function(){
        alert("handled!");
    }
    
    window.onload = function(){
        $("ajaxbtn").onclick = callAjax;
        
        //test Buttons for demonstrating handler functions
        $("testButton1").onclick = testButton1;
        $("testButton2").onclick = testButton2;
        
        // replace which function is in the "testButtonHandler" variable
        // since we know it will be given a parameter, take the value num
        testButtonHandler = function(num){
            console.log("handled " + num + "!");
        }
        
    };
    
    function testButton1() {
        testButtonHandler(1);
        
        // replace which function is in the "testButtonHandler" variable again
        testButtonHandler = function(num) {
            console.log("HAHAHAHA I CHANGED THE FUNCTION");
        }
    }
    
    function testButton2() {
        testButtonHandler(2);
    }
    
    //include this code, based on: https://developers.google.com/web/updates/2015/03/introduction-to-fetch
    function checkStatus(response) { 
        if (response.status >= 200 && response.status < 300 || response.status == 0) {  
            return response.text();
        } else {  
            return Promise.reject(new Error(response.status+": "+response.statusText)); 
        } 
    }
     
    // event handler for clicking the ajax button   
    function callAjax(){
        //use the github api to search for the word "fetch" in facebooks official code
        let url = "https://api.github.com/search/code?q=fetch+in:file+language:js+user:facebook";
        
        // dispaly loading text and disable button while ajax call is loading
        $("response").innerHTML = "Loading...";
        $("ajaxbtn").disabled = true;
        
        //start ajax call
        fetch(url) // can't include credentials for the github api, some ajax calls may need {mode: 'cors'}
           .then(checkStatus)
           .then(JSON.parse) // parse the json so the next "then" gets a JSON object
           .then(processGithubJson)
           .catch(function(error) {
               // ajax call failed! alert, place text and re-enable the button
               $("response").innerHTML = "THERE WAS AN ERROR!";
               alert(error);
               $("ajaxbtn").disabled = false;
           });
    }
    
    //process the json (we can count on the browser/promise to send the JSON object as the first parameter)
    function processGithubJson(responseJson) {
         $("response").innerHTML = ""; // clear out response box
         
        // print all the file names and repositories in the response box
        // use the json structure to find the values
        for(let i = 0; i< responseJson.items.length; i++){
            $("response").innerHTML += responseJson.items[i].name + " : " + responseJson.items[i].repository.full_name + 
            "<br>";
        }
        
        //re-enable the button
        $("ajaxbtn").disabled = false;
    }
    
})();